Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from build tree

From: Andrea Corallo <[email-masked]>
Date: Mon, 08 Mar 2021 15:38:46 +0000

Pip Cet <[email-masked]> writes:

> On Mon, Mar 8, 2021 at 3:03 PM Andrea Corallo <[email-masked]> wrote:
>> Pip Cet <[email-masked]> writes:
>> > On Mon, Mar 8, 2021 at 10:14 AM Andrea Corallo <[email-masked]> wrote:
>> > Have you modified dynlib_open() to leak the shared object? That's what
>> > I think might be happening for Eli, so it makes sense to test with a
>> > double dlopen() call, as I did.
>>
>> No, because I failed to understand why calling 'dlopen' two times in a
>> row on the same filename should make any difference as I expect the
>> second call to just return the same handle as the first.
>
> It does.
>
> What changes is that the next time we load the library, the first
> (leaky) dlopen() will have kept it in memory, so the third and fourth
> calls to dlopen() would also return the same handle as the first and
> second calls did.

Ah okay, IIUC the intent is to change the number of allocation so the
internal reference counter of GLIBC doesn't go to zero?

  Andrea